import os
import numpy as np
import torch
from timer import Timer
from ImageDataLoader import ImageDataLoader
from network import Network
from evaluate_model import evaluate_model
import scipy.io as sio
import time

def load_net(fname, net):
    import h5py
    h5f = h5py.File(fname, mode='r')
    for k, v in net.state_dict().items():        
        param = torch.from_numpy(np.asarray(h5f[k]))         
        v.copy_(param)

def test( nIndex,model_name,validdata_name ):

    valid_path = '/home/leequer/pytorch/new_data/'

    valdata_loader = ImageDataLoader(valid_path, validdata_name, shuffle=True, imresize=True, pre_load=True)
    
    name = validdata_name.replace( '.txt','' )
	
    path = '/home/leequer/like/model/'+ name  + '/model' + str(nIndex) + '/'
    model_path = path +model_name    

    print( 'model_path', model_path )

    net           = Network(nIndex)
    trained_model = os.path.join(model_path)
    load_net(trained_model, net)
    net.cuda()
    net.eval()
	
    count      = 0 
    total      = 0
    aprelable  = [] 
    alable     = []
    curvation  = [] 
    wetidx     = [] 
    flowacc    = [] 

    start=time.clock()

    for blob in valdata_loader:                        
        im_data    = blob['data']
        gt_data    = blob['label']
        dem        = blob['dem']
        slope      = blob['slope']
        img        = blob['imgg']
        #curvation  = blob['curvation']
        #wetidx     = blob['wetidx']
        #flowacc    = blob['flowacc'] 
        
        pre_label,featuremap = net(im_data,dem,slope,curvation,img,wetidx,flowacc,nIndex, gt_data)
        pre_label = pre_label.data.cpu().numpy()
        label = pre_label.argmax(axis=1).flatten()

        if gt_data == label:
            count = count+1
        total = total+1

        aprelable.append(label) 
        alable.append(gt_data) 

    end=time.clock()
    print (end-start)/300
    a = np.array(alable)
    b = np.array(aprelable)
    b=b.reshape(1,b.shape[0])
    a=a.reshape(1,a.shape[0])

    result = np.concatenate((a,b),axis=0) ;

    accu =  int(10000.0*count/total)/100.0

    sName = '_accu(' + str( accu ) + ').npy'

    model_path = model_path.replace('.h5',sName)

    np.save( model_path,result )

    print('Accuracy:',accu)


